// -*-C++-*-
/*!
 * @file  MyServiceSVC_impl.h
 * @brief Service implementation header of MyService.idl
 *
 */

#include "MyServiceSkel.h"
#include <rtm/CorbaConsumer.h>


#ifndef MYSERVICESVC_IMPL_H
#define MYSERVICESVC_IMPL_H
 
/*
 * Example class implementing IDL interface MyService
 */
class MyServiceSVC_impl
 : public virtual POA_MyService,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~MyServiceSVC_impl();

 public:
   // standard constructor
   MyServiceSVC_impl(RTC::CorbaConsumer<Callback>& cb);
   virtual ~MyServiceSVC_impl();

   // attributes and operations
   void _cxx_do();

private:
  RTC::CorbaConsumer<Callback>& m_cb;
};

/*
 * Example class implementing IDL interface Callback
 */
class CallbackSVC_impl
 : public virtual POA_Callback,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~CallbackSVC_impl();

 public:
   // standard constructor
   CallbackSVC_impl();
   virtual ~CallbackSVC_impl();

   // attributes and operations
   void done();

};



#endif // MYSERVICESVC_IMPL_H


